/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 * Generated by: OpenAPI Generator (https://openapi-generator.tech)
 */

package openapi

import (
	"context"
	"net/http"
)



// CancelProductOrderApiRouter defines the required methods for binding the api requests to a responses for the CancelProductOrderApi
// The CancelProductOrderApiRouter implementation should parse necessary information from the http request, 
// pass the data to a CancelProductOrderApiServicer to perform the required actions, then write the service results to the http response.
type CancelProductOrderApiRouter interface { 
	CreateCancelProductOrder(http.ResponseWriter, *http.Request)
	ListCancelProductOrder(http.ResponseWriter, *http.Request)
	RetrieveCancelProductOrder(http.ResponseWriter, *http.Request)
}
// EventsSubscriptionApiRouter defines the required methods for binding the api requests to a responses for the EventsSubscriptionApi
// The EventsSubscriptionApiRouter implementation should parse necessary information from the http request, 
// pass the data to a EventsSubscriptionApiServicer to perform the required actions, then write the service results to the http response.
type EventsSubscriptionApiRouter interface { 
	RegisterListener(http.ResponseWriter, *http.Request)
	UnregisterListener(http.ResponseWriter, *http.Request)
}
// NotificationListenersClientSideApiRouter defines the required methods for binding the api requests to a responses for the NotificationListenersClientSideApi
// The NotificationListenersClientSideApiRouter implementation should parse necessary information from the http request, 
// pass the data to a NotificationListenersClientSideApiServicer to perform the required actions, then write the service results to the http response.
type NotificationListenersClientSideApiRouter interface { 
	ListenToCancelProductOrderCreateEvent(http.ResponseWriter, *http.Request)
	ListenToCancelProductOrderInformationRequiredEvent(http.ResponseWriter, *http.Request)
	ListenToCancelProductOrderStateChangeEvent(http.ResponseWriter, *http.Request)
	ListenToProductOrderAttributeValueChangeEvent(http.ResponseWriter, *http.Request)
	ListenToProductOrderCreateEvent(http.ResponseWriter, *http.Request)
	ListenToProductOrderDeleteEvent(http.ResponseWriter, *http.Request)
	ListenToProductOrderInformationRequiredEvent(http.ResponseWriter, *http.Request)
	ListenToProductOrderStateChangeEvent(http.ResponseWriter, *http.Request)
}
// ProductOrderApiRouter defines the required methods for binding the api requests to a responses for the ProductOrderApi
// The ProductOrderApiRouter implementation should parse necessary information from the http request, 
// pass the data to a ProductOrderApiServicer to perform the required actions, then write the service results to the http response.
type ProductOrderApiRouter interface { 
	CreateProductOrder(http.ResponseWriter, *http.Request)
	DeleteProductOrder(http.ResponseWriter, *http.Request)
	ListProductOrder(http.ResponseWriter, *http.Request)
	PatchProductOrder(http.ResponseWriter, *http.Request)
	RetrieveProductOrder(http.ResponseWriter, *http.Request)
}


// CancelProductOrderApiServicer defines the api actions for the CancelProductOrderApi service
// This interface intended to stay up to date with the openapi yaml used to generate it, 
// while the service implementation can ignored with the .openapi-generator-ignore file 
// and updated with the logic required for the API.
type CancelProductOrderApiServicer interface { 
	CreateCancelProductOrder(context.Context, CancelProductOrderCreate) (ImplResponse, error)
	ListCancelProductOrder(context.Context, string, int32, int32) (ImplResponse, error)
	RetrieveCancelProductOrder(context.Context, string, string) (ImplResponse, error)
}


// EventsSubscriptionApiServicer defines the api actions for the EventsSubscriptionApi service
// This interface intended to stay up to date with the openapi yaml used to generate it, 
// while the service implementation can ignored with the .openapi-generator-ignore file 
// and updated with the logic required for the API.
type EventsSubscriptionApiServicer interface { 
	RegisterListener(context.Context, EventSubscriptionInput) (ImplResponse, error)
	UnregisterListener(context.Context, string) (ImplResponse, error)
}


// NotificationListenersClientSideApiServicer defines the api actions for the NotificationListenersClientSideApi service
// This interface intended to stay up to date with the openapi yaml used to generate it, 
// while the service implementation can ignored with the .openapi-generator-ignore file 
// and updated with the logic required for the API.
type NotificationListenersClientSideApiServicer interface { 
	ListenToCancelProductOrderCreateEvent(context.Context, CancelProductOrderCreateEvent) (ImplResponse, error)
	ListenToCancelProductOrderInformationRequiredEvent(context.Context, CancelProductOrderInformationRequiredEvent) (ImplResponse, error)
	ListenToCancelProductOrderStateChangeEvent(context.Context, CancelProductOrderStateChangeEvent) (ImplResponse, error)
	ListenToProductOrderAttributeValueChangeEvent(context.Context, ProductOrderAttributeValueChangeEvent) (ImplResponse, error)
	ListenToProductOrderCreateEvent(context.Context, ProductOrderCreateEvent) (ImplResponse, error)
	ListenToProductOrderDeleteEvent(context.Context, ProductOrderDeleteEvent) (ImplResponse, error)
	ListenToProductOrderInformationRequiredEvent(context.Context, ProductOrderInformationRequiredEvent) (ImplResponse, error)
	ListenToProductOrderStateChangeEvent(context.Context, ProductOrderStateChangeEvent) (ImplResponse, error)
}


// ProductOrderApiServicer defines the api actions for the ProductOrderApi service
// This interface intended to stay up to date with the openapi yaml used to generate it, 
// while the service implementation can ignored with the .openapi-generator-ignore file 
// and updated with the logic required for the API.
type ProductOrderApiServicer interface { 
	CreateProductOrder(context.Context, ProductOrderCreate) (ImplResponse, error)
	DeleteProductOrder(context.Context, string) (ImplResponse, error)
	ListProductOrder(context.Context, string, int32, int32) (ImplResponse, error)
	PatchProductOrder(context.Context, string, ProductOrderUpdate) (ImplResponse, error)
	RetrieveProductOrder(context.Context, string, string) (ImplResponse, error)
}
